#ifndef defines_H_
#define defines_H_										// header guard:

//-------------------------------------------------------------------------------------------------------------------
//	Define common pins
//
#define pin_CSether			10							// define Ethernet chip select line:
#define LED 13

//-------------------------------------------------------------------------------------------------------------------
//	Define constants
//
#define PID_MIN 0
#define PID_MAX 1023

#define pin_LCD_BACKLIGHT	0x08
#define pin_LCD_NOBACKLIGHT	0x00

#define keySelect			1
#define keyUp				2
#define keyDown				3
#define keyInc				12
#define keyDec				13

#define keyLeft				22
#define keyRight			23

#define pin_SELECT			A0
#define pin_UP				A1
#define pin_DOWN			A2
#define pin_LEFT			A3
#define pin_RIGHT			A4

//#define SERIAL_DEBUG	false
//#define HAVE_LCD										// if LCD present:
//#define HAVE_VT100									// if serial VT100 / VT220 terminal:

#define vtfDefault			"\x1b[39m"
#define vtfBlack			"\x1b[30m"
#define vtfRed				"\x1b[31m"
#define vtfGreen			"\x1b[32m"
#define vtfYellow			"\x1b[33m"
#define vtfBlue				"\x1b[34m"
#define vtfMagenta			"\x1b[35m"
#define vtfCyan				"\x1b[36m"
#define vtfLightGrey		"\x1b[37m"
#define vtfDarkGrey			"\x1b[90m"
#define vtfLightRed			"\x1b[91m"
#define vtfLightGreen		"\x1b[92m"
#define vtfLightYellow		"\x1b[93m"
#define vtfLightBlue		"\x1b[94m"
#define vtfLightMagenta		"\x1b[95m"
#define vtfLightCyan		"\x1b[96m"
#define vtfWhite			"\x1b[97m"

#define vtbDefault			"\x1b[49m"
#define vtbBlack			"\x1b[40m"
#define vtbRed				"\x1b[41m"
#define vtbGreen			"\x1b[42m"
#define vtbYellow			"\x1b[43m"
#define vtbBlue				"\x1b[44m"
#define vtbMagenta			"\x1b[45m"
#define vtbCyan				"\x1b[46m"
#define vtbLightGrey		"\x1b[47m"
#define vtbDarkGrey			"\x1b[100m"
#define vtbLightRed			"\x1b[101m"
#define vtbLightGreen		"\x1b[102m"
#define vtbLightYellow		"\x1b[103m"
#define vtbLightBlue		"\x1b[104m"
#define vtbLightMagenta		"\x1b[105m"
#define vtbLightCyan		"\x1b[106m"
#define vtbWhite			"\x1b[107m"

#define vtNorm				"\x1b[0m"
#define	vtBright			"\x1b[1m"
#define vtDim				"\x1b[2m"
#define vtUnder				"\x1b[4m"
#define vtBlink				"\x1b[5m"
#define vtReverse			"\x1b[7m"

#define posd1				"\x1b[1B"					// move cursor down one line:
#define clearEOL			"\x1b[K"					// clear from cursor to end of line:

#define posx4				"\x1b[4G"
#define posx8				"\x1b[8G"
#define posx12				"\x1b[12G"
#define posx16				"\x1b[16G"
#define posx20				"\x1b[20G"
#define posx24				"\x1b[24G"
#define posx28				"\x1b[28G"
#define posx32				"\x1b[32G"
#define posx36				"\x1b[36G"
#define posx40				"\x1b[40G"
#define posx44				"\x1b[44G"
#define posx48				"\x1b[48G"
#define posx52				"\x1b[52G"
#define posx56				"\x1b[56G"
#define posx60				"\x1b[60G"
#define posx64				"\x1b[64G"
#define posx68				"\x1b[68G"
#define posx72				"\x1b[72G"
#define posx76				"\x1b[76G"
#define posx80				"\x1b[80G"

//-------------------------------------------------------------------------------------------------------------------
//	Define CPU based pins
//	This will automatically select the correct board based on IDE config board settings:
//
#if defined(__AVR_ATmega328P__)							// AVR 328 CPU as found on UNO:
	#define MB_SERIAL_PORT	&Serial						// Modbus serial port on first and only port:
	#define PIN_OUTPUT_A	TIMER1_A_PIN				// pin 9 for load element 1:
	#define PIN_OUTPUT_B	TIMER1_B_PIN				// pin 10 for load element 2:
#endif

#if defined(__AVR_ATmega2560__)							// AVR 2560 CPU as found on Mega:
	#define MB_SERIAL_PORT	&Serial1					// Modbus serial port on second port #if defined(HAVE_HWSERIAL1):
	#define	pin_SPI_CS		53							// define SPI chip select line:
	#define PIN_OUTPUT_A	TIMER1_A_PIN				// pin 11 for load element 1:
	#define PIN_OUTPUT_B	TIMER1_B_PIN				// pin 12 for load element 2:
#endif /* defined(__AVR_ATmega2560__) */

#endif /* defines_H_ */
