#ifndef pidControl_H_
#define pidControl_H_

#include <Arduino.h>

class	PID {
	public:
		int16_t		pvPID;
		int16_t		spPID;
		int16_t		errPID;
		int16_t		intPID;
		int16_t		derPID;
		int16_t		pvLast;
		int16_t		cvPID;
		int16_t		kpPID;									// gain constant for proportional term ~ 1:
		int16_t		kiPID;									// gain constant for integral term ~ 2:
		int16_t		kdPID;									// gain constant for derivative term ~ 5:
		int16_t		outMinPID;								// pid output minimum clamp value ~ 0:
		int16_t		outMaxPID;								// pid output maximum clamp value ~ 1023:

	PID(int16_t _sp, int16_t _kp, int16_t _ki, int16_t _kd, int16_t _outMin, int16_t _outMax);
	void loop();
	void spChange(int16_t _sp);
	void kpChange(int16_t _kp);

	private:
};


#endif
